SystemOrganization addCategory: #ArtificalMouseClick!

Object subclass: #ArtificalMouseClick
	instanceVariableNames: 'clickPosition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ArtificalMouseClick'!

!ArtificalMouseClick methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/2/2012 21:14'!
click
|mouseDownEvent mouseUpEvent morphThatHandlesMouseClick|
mouseDownEvent := self newMouseDownEvent.
mouseUpEvent := self newMouseUpEvent.

morphThatHandlesMouseClick := self targetMorphs detect: [:m| m handlesMouseDown: mouseDownEvent]. 
mouseDownEvent sentTo: morphThatHandlesMouseClick.
mouseUpEvent sentTo: morphThatHandlesMouseClick.
! !

!ArtificalMouseClick methodsFor: 'accessing' stamp: 'HwaJong 10/2/2012 21:16'!
clickPosition: aPoint
clickPosition:= aPoint! !

!ArtificalMouseClick methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/2/2012 21:06'!
getClickPositionFromUser
clickPosition := Point fromUser.! !

!ArtificalMouseClick methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/2/2012 21:09'!
go
self getClickPositionFromUser.
self click.
! !

!ArtificalMouseClick methodsFor: 'private' stamp: 'HwaJong 10/2/2012 21:13'!
newMouseDownEvent
|event|
event := MouseButtonEvent new.
event setType: #mouseDown position: clickPosition which: MouseEvent redButton buttons: MouseEvent redButton hand: ActiveHand stamp: Time millisecondClockValue.
^event! !

!ArtificalMouseClick methodsFor: 'private' stamp: 'HwaJong 10/2/2012 21:13'!
newMouseUpEvent
|event|
event := MouseButtonEvent new.
event setType: #mouseUp position: clickPosition which: MouseEvent redButton buttons: MouseEvent redButton hand: ActiveHand stamp: Time millisecondClockValue.
^event! !

!ArtificalMouseClick methodsFor: 'private' stamp: 'HwaJong 10/2/2012 21:06'!
targetMorphs
^World morphsAt: clickPosition! !
